/* Various configuration options

   Cygnus IRC Services - Copyright (c) 2001-2002 Darcy Grexton
   Contact: skold@habber.net, skold @ HabberNet, ICQ #6285178

   This program is free but copyrighted software; see the file COPYING
   for details.
 */

/* Change these to suit your liking. */
#define CONFIGFILE	"cygnus.conf"		/* Our conf file	*/
#define PIDFILE		"cygnus.pid"		/* Our PID file		*/
#define LOGFILE		"cygnus.log"		/* Our log file		*/
#define MOTDFILE	"cygnus.motd"		/* Our MOTD file	*/
#define NEWSFILE	"cygnus.news"		/* Our News file	*/
#define NICKSERV_DB	"nickserv.db"		/* NickServ DB		*/
#define CHANSERV_DB	"chanserv.db"		/* ChanServ DB		*/
#define ROOTSERV_DB	"rootserv.db"		/* RootServ DB		*/
#define NSREGISTER	"nsregister.email"	/* NS REGISTER E-Mail	*/
#define NSSENDPASS	"nssendpass.email"	/* NS SENDPASS E-Mail	*/
#define NSCHANGE	"nschange.email"	/* NS Change E-Mail	*/
#define CSREGISTER	"csregister.email"	/* CS REGISTER E-Mail	*/
#define CSSENDPASS	"cssendpass.email"	/* CS SENDPASS E-Mail	*/
#define MSMEMOMAIL	"msmemomail.email"	/* MS MEMOMAIL E-Mail	*/

/* These values should be sufficient on any supported IRCDs. */
#define NICKLEN		32	/* Maximum length of a nickname		*/
#define CHANNELLEN	64	/* Maximum length of a channel name	*/
#define PASSWDLEN	32	/* Maximum length of a password		*/
#define USERLEN		10	/* Maximum length of a username		*/
#define HOSTLEN		63	/* Maximum length of a hostname		*/
#define REALLEN		50	/* Maximum length of a realname		*/
#define TOPICLEN	307	/* Maximum length of a channel topic	*/
#define KEYLEN		23	/* Maximum length of a channel key	*/

/* Leave these alone too. */
#define BUFSIZE		512	/* Maximum size of a buffer		*/
#define MODESTACK_WAIT	500	/* Time (in ms) to wait for modes	*/

/* Do you want Cygnus to generate a core file if it crashes?
   I'd suggest you leave this option on. If you experience crashes,
   the core files generated can help me track down the problem and
   fix it.
 */
#define DUMP_CORE

/* Do you want to enable the RAW and INJECT functions? These functions
   are entirely unsupported. If you crash Cygnus or your IRCd while
   using them (and it's entirely possible and quite easy to do both),
   tough luck. If you don't know how to do anything with them, tough luck.
   Do not ask me for a list of RAW and INJECT commands. If you enable
   these, you're on your own. They're not toys. :P
 */
#undef RAWINJECT
