#define _GNU_SOURCE

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <errno.h>
#include <setjmp.h>
#include <sys/stat.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <grp.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/resource.h>

/* This is for HabberNet. You don't need it. */
#undef HABBER

#define E extern

/* Channel Modes */
#define CMODE_t		0x00000001
#define CMODE_n		0x00000002
#define CMODE_s		0x00000004
#define CMODE_m		0x00000008
#define CMODE_l		0x00000010	
#define CMODE_i		0x00000020
#define CMODE_p		0x00000040
#define CMODE_k		0x00000080
#define CMODE_o		0x00000100
#define CMODE_v		0x00000200
#define CMODE_R		0x00000400
#define CMODE_r		0x00000800
#define CMODE_c		0x00001000
#define CMODE_O		0x00002000
#define CMODE_Q		0x00004000
#define CMODE_S		0x00008000
#define CMODE_K		0x00010000
#define CMODE_V		0x00020000
#define CMODE_f		0x00040000
#define CMODE_H		0x00080000
#define CMODE_G		0x00100000
#define CMODE_C		0x00200000
#define CMODE_u		0x00400000
#define CMODE_z		0x00800000
#define CMODE_N		0x01000000
#define CMODE_L		0x02000000
#define CMODE_A		0x04000000
#define CMODE_h		0x08000000
#define CMODE_a		0x10000000
#define CMODE_q		0x20000000

/* Structure for modes */
struct flag {
    char mode;
    long flag;
    char prefix;
};

/* Hash table for channel modes */
static const struct flag cmodes[] = {
    {'t',	CMODE_t},
    {'n',	CMODE_n},
    {'s',	CMODE_s},
    {'m',	CMODE_m},
    {'l',	CMODE_l},
    {'i',	CMODE_i},
    {'p',	CMODE_p},
    {'k',	CMODE_k},
    {'r',	CMODE_r},
    {'R',	CMODE_R},
    {'c',	CMODE_c},
    {'O',	CMODE_O},
    {'Q',	CMODE_Q},
    {'S',	CMODE_S},
    {'K',	CMODE_K},
    {'V',	CMODE_V},
    {'f',	CMODE_f},
    {'H',	CMODE_H},
    {'G',	CMODE_G},
    {'C',	CMODE_C},
    {'u',	CMODE_u},
    {'z',	CMODE_z},
    {'N',	CMODE_N},
    {'L',	CMODE_L},
    {'A',	CMODE_A},
    {0,		0}
};

/* Cygnus stuff */
#define CMF_EMAILED	0x00000002

#define CNF_ENFORCE	0x00000001
#define CNF_SECURE	0x00000002
#define CNF_HIDEMAIL	0x00000004
#define CNF_NEVEROP	0x00000010
#define CNF_NOOP	0x00000020
#define CNF_NOSUCCESSOR	0x00000040
#define CNF_PRIVATE	0x00000080
#define CNF_PRIVMSG	0x00000200
#define CNF_NOMEMO	0x00000400
#define CNF_MEMOMAIL	0x00001000
#define CNF_FROZEN	0x00002000
#define CNF_HELD	0x00004000
#define CNF_MARKED	0x00008000
#define CNF_LINKED	0x10000000
#define CNF_CSOP	0x20000000

#define CCF_VERBOSE	0x00000001
#define CCF_VOPALL	0x00000002
#define CCF_SECURE	0x00000004
#define CCF_RESTRICTED	0x00000008
#define CCF_FROZEN	0x00000010
#define CCF_HELD	0x00000020
#define CCF_MARKED	0x00000040

/* WreckedNet Stuff */
E int convert_wrecked_db (void);
E int load_wrecked_ns (void);
E int load_wrecked_ms (void);
E int load_wrecked_cs (void);
E int load_wrecked_rs (void);
E int save_wrecked_ns (void);
E int save_wrecked_cs (void);
E int save_wrecked_rs (void);

#define	CHANMAX_WRECKED	64
#define	NICKMAX_WRECKED	32
#define	PASSMAX_WRECKED	32

typedef struct nickinfo_wrecked NickInfo_Wrecked;
typedef struct memo_wrecked Memo_Wrecked;
typedef struct memolist_wrecked MemoList_Wrecked;
typedef struct chanaccess_wrecked ChanAccess_Wrecked;
typedef struct autokick_wrecked AutoKick_Wrecked;
typedef struct chaninfo_wrecked ChannelInfo_Wrecked;
typedef struct akill_wrecked AutoKill_Wrecked;
typedef struct allow_wrecked Allow_Wrecked;
typedef struct sop_wrecked SOP_Wrecked;

#define	WMF_UNREAD	0x00000001
#define WMF_EMAILED	0x00000004

#define	WNI_KILLPROTECT	0x00000001
#define	WNI_SECURE	0x00000002
#define	WNI_VERBOTEN	0x00000004
#define	WNI_IRCOP	0x00000008
#define	WNI_PRIVATE	0x00000010
#define	WNI_SUSPENDED	0x00000020
#define	WNI_PRIVMSG	0x00000040
#define WNI_SLAVE	0x00000080
#define WNI_NOMEMO	0x00000100
#define WNI_HIDEMAIL	0x00000200
#define WNI_NEVEROP	0x00000400
#define WNI_NOOP	0x00000800
#define WNI_MARKED	0x00001000
#define WNI_MEMOMAIL	0x00002000
#define WNI_HOLD	0x00004000
#define	WNI_IDENTIFIED	0x80000000
#define	WNI_RECOGNIZED	0x40000000

#define	WCI_KEEPTOPIC	0x00000001
#define	WCI_SECUREOPS	0x00000002
#define	WCI_PRIVATE	0x00000004
#define	WCI_TOPICLOCK	0x00000008
#define	WCI_RESTRICTED	0x00000010
#define	WCI_LEAVEOPS	0x00000020
#define	WCI_SECURE	0x00000040
#define	WCI_VERBOTEN	0x00000080
#define	WCI_SUSPENDED	0x00000100
#define	WCI_JOIN	0x00000200
#define WCI_HOLD	0x00000400
#define WCI_MARKED	0x00000800
#define WCI_VERBOSE	0x00001000
#define WCI_VOPALL	0x00002000

struct nickinfo_wrecked {
    NickInfo_Wrecked *next, *prev;
    char nick[NICKMAX_WRECKED];
    char pass[PASSMAX_WRECKED];
    char *email;
    char *url;
    char *last_usermask;
    char *last_realname;
    time_t time_registered;
    time_t last_seen;
    long accesscount;
    char **access;
    long ignorecount;
    char **ignore;
    long flags;
    long reserved[4];
    time_t last_signon;
    long uin;
};

struct memo_wrecked {
    char sender[NICKMAX_WRECKED];
    long number;
    time_t time;
    char *text;
    long flags;
    long reserved[4];
};

struct memolist_wrecked {
    MemoList_Wrecked *next, *prev;
    char nick[NICKMAX_WRECKED];
    long n_memos;
    Memo_Wrecked *memos;
    long reserved[4];
};

struct chanaccess_wrecked {
    short level;
    short is_nick;
    char *name;
};

struct autokick_wrecked {
    short is_nick;
    short pad;
    char *name;
    char *reason;
};

struct chaninfo_wrecked {
    ChannelInfo_Wrecked *next, *prev;
    char name[CHANMAX_WRECKED];
    char founder[NICKMAX_WRECKED];
    char founderpass[PASSMAX_WRECKED];
    char *desc;
#ifdef HABBER
    char *greet;
#endif
    char *url;
    time_t time_registered;
    time_t last_used;
    long accesscount;
    ChanAccess_Wrecked *access;
    long akickcount;
    AutoKick_Wrecked *akick;
    char mlock_on[64], mlock_off[64];
    long mlock_limit;
    char *mlock_key;
    char *last_topic;
    char last_topic_setter[NICKMAX_WRECKED];
    time_t last_topic_time;
    long flags;
    short *cmd_access;
    long reserved[3];
};

struct akill_wrecked {
    char *mask;
    char *reason;
    char who[NICKMAX_WRECKED];
    time_t time;
};

struct allow_wrecked {
    char *host;
    int amount;
    char *reason;
    char who[NICKMAX_WRECKED];
    time_t time;
};

struct sop_wrecked {
    char nick[NICKMAX_WRECKED];
};
