/* External functions

   Cygnus IRC Services - Copyright (c) 2001-2002 Darcy Grexton
   Contact: skold@habber.net, skold @ HabberNet, ICQ #6285178

   This program is free but copyrighted software; see the file COPYING
   for details.
 */

#define E extern	/* Save us some typing */

/* socket.c */
E int conn (const char *host, int port, const char *lhost, int lport);
E void disconn (int s);
E void sendtoserver (char *fmt,...);
E void read_loop();

/* main.c */
E Verify *verifylist[1024];
E EMail *emaillist[1024];
E char quitmsg[BUFSIZE], inbuf[BUFSIZE * 8];
E int servsock, servcnt, usercnt, chancnt, userstat;
#if defined (BAHAMUT) || defined (PROMETHEUS) || defined (UNREAL3)
E int bursting;
E time_t burststart;
#endif
#ifdef BAHAMUT
E int bursted;
#endif
E int debuglevel;
E long runflags;
E time_t news_time;
E void intro_user (const char *nick, const char *user, const char *host, const char *real, const char *modes);
E int is_one_of_mine (const char *nick);
E int servcount (void);
E const char version[];
E const char build[];
E const char compile_time[];
E const char *infotext[];
E void chk (void);

/* function.c */
E void open_log ();
E void open_debug ();
E void log (const char *fmt,...);
E void log_sameline (int sameline, const char *fmt,...);
E void debug (const char *fmt,...);
E void close_log ();
E void close_debug ();
E void fatal (const char *fmt,...);
E void send_cmd (const char *source, const char *fmt, ...);
E void vsend_cmd (const char *source, const char *fmt, va_list args);
E void notice (const char *source, const char *dest, const char *fmt, ...); 
E void opnotice (const char *source, const char *dest, const char *fmt,...);
E void noticeall (const char *fmt, ...);
E void noticecsops (const char *source, const char *fmt, ...);
E void globops (const char *whoami, const char *fmt, ...);
E void ctcpreply (const char *source, const char *dest, const char *fmt, ...);
E int is_sra (const char *nick);
E int is_csop (const char *nick);
E int is_oper (const char *nick);
E int is_on_chan (const char *nick, const char *chan);
E int is_opped (const char *nick, const char *chan);
E int is_voiced (const char *nick, const char *chan);
#ifdef UNREAL3
E int is_halfopped (const char *nick, const char *chan);
#endif
E int can_sra (const char *nick);
E int can_csop (const char *nick);
E int stricmp (const char *s1, const char *s2);
E size_t sstrlcpy (char *dst, const char *src, size_t siz);
E size_t sstrlcat (char *dst, const char *src, size_t siz);
E void *smalloc (long size);
E void *scalloc (long elsize, long els);
E void *srealloc (void *oldptr, long newsize);
E char *sstrdup (const char *s);
E char *stristr (char *s1, char *s2);
E int match_wild (const char *pattern, const char *str);
E int match_wild_nocase (const char *pattern, const char *str);   
E char *strupper (char *s);
E char *strlower (char *s);
E void strip (char *line);
E void notice_list (const char *source, const char *dest, const char **text);
E SRA *findsra (const char *nick);
E int is_akilled (const char *mask);
E int dotime (const char *s);
E char *create_mask (User *u);
E void snoop (const char *source, const char *fmt,...);
E char *duration (time_t event, int format);
E char *strscpy (char *d, const char *s, size_t len);
E char *time_ago (time_t event);
E char *get_time (time_t event, int fulldate);
E char *stripcodes (char *buffer);
E char *replace (char *string, char *oldpiece, char *newpiece);
E char *itoa (int num);
E void flushlists (void);
E NickInfo *findnick (const char *nick);
E NickInfo *nextni (void);
E NickInfo *firstni (void);
E NickInfo *get_nick (User *u);
E int ispass (char *text);
E int isctcp (char *command);
E int validemail (char *email, const char *source);
E Verify *findverify (const char *name);
E EMail *findemail (const char *email);
E int check_email (const char *source, const char *email);
E void expire_emails (void);
E void check_verifies (User *u);
E void verify_notice (Verify *vf);
E unsigned long makekey (void);
E void sendemail (const char *what, const char *param, int type);
E int check_ns_auth (const char *whoami, const char *source, NickInfo *ni);
E int check_cs_auth (const char *whoami, const char *source, ChanInfo *ci);
E void errmoreinfo (const char *whoami, const char *source, char *text);
E void joinchan_join (void);
E void joinchan_part (void);
E int32 string_to_flags (char *modes);
E char *flags_to_string (int32 flags);
E int32 mode_to_flag (char c);
E char mode_to_char (int32 f);
E int32 prefix_to_flag (char c);
E uint32 time_msec (void);
E int tv2ms (struct timeval *tv);
E void check_eb (void);
E void notify_new_memo (NickInfo *ni, char *from);

/* process.c */
E int split_buf (char *buf, char ***argv, int colon_special);
E void process (void);

/* timeout.c */
E void check_timeouts (void);
E Timeout *add_timeout_ms (int delay, void (*code)(Timeout *), int repeat);
E Timeout *add_timeout (int delay, void (*code)(Timeout *), int repeat);
E void del_timeout (Timeout *t);
E void add_ns_timeout (NickInfo *ni, int type, time_t delay);
E void add_cs_timeout (ChanInfo *ci, int type, time_t delay);
E void del_ns_timeout (NickInfo *ni, int type, int del_to);
E void del_cs_timeout (ChanInfo *ci, int type, int del_to);

/* conf.c */
E SRA *sralist;
E void load_conf (void);
E int check_conf (void);
E char s_RootServ[NICKLEN], s_NickServ[NICKLEN], s_MemoServ[NICKLEN];
E char s_ChanServ[NICKLEN], s_GlobalNoticer[NICKLEN];
E char tlds[64], snoopchan[32], def_akill_reason[256], joinchan[32];
E char sendmail_path[512], network_name[32], nsregister_url[256];
E char memomail_url[256], csregister_url[256], collision_url[256];
E char def_topic[350], def_modes[32], def_akick_reason[256], globalmsg[64];
E Boolean_T rootserv_on, nickserv_on, chanserv_on, memoserv_on, age_on, sex_on;
E Boolean_T globalnoticer_on, globalonakill_on, logupdates_on, learnakills_on;
E Boolean_T forgetakills_on, location_on, name_on, privmsg_on, showmail_on;
E Boolean_T email_on, url_on, uin_on, sendmail_on, memomail_on, securesra_on;
E Boolean_T globalonauth_on, haveserv_on, statglobal_on;
E Boolean_T noisyflood_on;
#ifdef UNREAL3
E Boolean_T fakehost_on;
#endif
E int update_timeout, nonwildreq, def_akill_time, unreal_numeric, maxlinks;
E int wait_restart, maxclones, maxclonekills, nick_expire, chan_expire, csregistertype;
E int memo_delay, nick_delay, chan_delay, memobox_size, memomailmax, passfails;
E int memosfromuser, securitysetting, emaillimit, nsregistertype, tempexpire, chanlimit;
E int collidetype, floodmsgs, akickmax, helpindex;
E time_t floodtime;
E long defnickflags, defchanflags, defmlock_on, defmlock_off;

/* server.c */
E Servers *servlist;
E Clone *findclone (const char *host);
E Clone *clonelist[1024];
E User *finduser (const char *nick);
E User *firstuser (void);
E User *nextuser (void);
E User *userlist[1024];
E Channel *findchan (const char *chan);
E Channel *firstchan (void);
E Channel *nextchan (void);
E Channel *chanlist[1024];
E Channel *chan_adduser (User *user, const char *chan, int32 modes);
E void chan_deluser (User *user, Channel *c);
E void do_nick (const char *source, int ac, char **av);
E void do_join (const char *source, int ac, char **av);
E void do_part (const char *source, int ac, char **av);
E void do_kick (const char *source, int ac, char **av);
E void do_umode (const char *source, int ac, char **av);
E void do_quit (const char *source, int ac, char **av);
E void do_kill (const char *source, int ac, char **av);
E void do_umode (const char *source, int ac, char **av);
E void do_cmode (const char *source, int ac, char **av);
E void do_topic (const char *source, int ac, char **av);
E void kill_user (const char *source, const char *user, const char *reason);
E int countusermask (const char *mask);
E User *findusermask (const char *mask, int matchno);
E void delete_user (User * user);
#if defined (BAHAMUT) || defined (PROMETHEUS) || defined (UNREAL3)
E void do_sjoin (const char *source, int ac, char **av);
#endif
E void send_cmode (const char *sender, ...);
E void flush_cmodes (void);

/* rootserv.c */
E AutoKill *akilllist[1024];
E Trigger *triggerlist;
E Exception *exceptionlist;
E void globalnoticer (const char *source, char *buf);
E void rootserv (const char *source, char *buf);
E int check_akill (const char *nick, const char *user, const char *host, const char *real);
E void load_rs_dbase (void);
E void save_rs_dbase (void);
E void expire_akills (void);
E void do_rehash (const char *source);
E Trigger *new_trigger (const char *host, int limit);
E Trigger *findtrig (const char *user, const char *host);
E Exception *findexcept (const char *user, const char *host);
E Exception *new_exception (const char *host);

/* nickserv.c */
E NickInfo *nicklist[1024];
E int sstamp;
E void nickserv (const char *source, char *buf);
E void load_ns_dbase (void);
E void save_ns_dbase (void);
E int validate_user (User *u);
E void cancel_user (User * u);
E void release (NickInfo *ni, int from_timeout);
E void collide (NickInfo *ni, int from_timeout);
E void expire_nicks (void);
E int islinked (const char *nick, NickInfo *ni);

/* chanserv.c */
E ChanInfo *cs_chanlist[1024];
E int delchan (ChanInfo *ci);
E ChanInfo *cs_findchan (const char *chan);
E ChanInfo *firstci (void);
E ChanInfo *nextci (void);
E void chanserv (const char *source, char *buf);
E void load_cs_dbase (void);
E void save_cs_dbase (void);
E void expire_chans (void);
E void restore_channel (Channel *c);
E void check_modes (const char *chan);
E void set_topic (ChanInfo *ci, const char *topic, const char *setter);
E int get_access (User *u, ChanInfo *ci);
#if defined (BAHAMUT) || defined (PROMETHEUS) || defined (UNREAL3)
E int cs_join (User *u, const char *c, int fromburst);
#else
E int cs_join (User *u, const char *c);
#endif

/* memoserv.c */
E void memoserv (const char *source, char *buf);
E void check_memos (User *u);

/* help.c */
E void nickserv_help_index (const char *source);
E void nickserv_help_register (const char *source);
E void nickserv_help_drop (const char *source);
E void nickserv_help_identify (const char *source);
E void nickserv_help_set (const char *source);
E void nickserv_help_access (const char *source);
E void nickserv_help_recover (const char *source);
E void nickserv_help_link (const char *source);
E void nickserv_help_unlink (const char *source);
E void nickserv_help_links (const char *source);
E void nickserv_help_chans (const char *source);
E void nickserv_help_status (const char *source);
E void nickserv_help_info (const char *source);
E void nickserv_help_getpass (const char *source);
E void nickserv_help_setpass (const char *source);
E void nickserv_help_sendpass (const char *source);
E void nickserv_help_freeze (const char *source);
E void nickserv_help_unfreeze (const char *source);
E void nickserv_help_hold (const char *source);
E void nickserv_help_unhold (const char *source);
E void nickserv_help_mark (const char *source);
E void nickserv_help_unmark (const char *source);
E void chanserv_help_index (const char *source);
E void chanserv_help_register (const char *source);
E void chanserv_help_drop (const char *source);
E void chanserv_help_identify (const char *source);
E void chanserv_help_info (const char *source);
E void chanserv_help_list (const char *source);
E void chanserv_help_set (const char *source);
E void chanserv_help_count (const char *source);
E void chanserv_help_vop (const char *source);
#ifdef UNREAL3
E void chanserv_help_hop (const char *source);
#endif
E void chanserv_help_aop (const char *source);
E void chanserv_help_sop (const char *source);
E void chanserv_help_op (const char *source);
E void chanserv_help_deop (const char *source);
#ifdef UNREAL3
E void chanserv_help_halfop (const char *source);
E void chanserv_help_dehalfop (const char *source);
#endif
E void chanserv_help_voice (const char *source);
E void chanserv_help_devoice (const char *source);
E void chanserv_help_akick (const char *source);
E void chanserv_help_freeze (const char *source);
E void chanserv_help_unfreeze (const char *source);
E void chanserv_help_getpass (const char *source);
E void chanserv_help_setpass (const char *source);
E void chanserv_help_sendpass (const char *source);
E void chanserv_help_auth (const char *source);
E void memoserv_help_index (const char *source);
E void memoserv_help_send (const char *source);
E void memoserv_help_read (const char *source);
E void memoserv_help_del (const char *source);
E void memoserv_help_list (const char *source);
E void memoserv_help_recall (const char *source);
E void memoserv_help_set (const char *source);
E void memoserv_help_news (const char *source);
E void rootserv_help_index (const char *source);
E void rootserv_help_auth (const char *source);
E void rootserv_help_deauth (const char *source);
E void rootserv_help_akill (const char *source);
E void rootserv_help_jupe (const char *source);
E void rootserv_help_settings (const char *source);
E void rootserv_help_csop (const char *source);
E void rootserv_help_global (const char *source);
E void rootserv_help_clones (const char *source);
E void rootserv_help_trigger (const char *source);
E void rootserv_help_exception (const char *source);
E void rootserv_help_stats (const char *source);
E void rootserv_help_search (const char *source);
E void rootserv_help_shutdown (const char *source);
E void rootserv_help_restart (const char *source);
E void rootserv_help_debug (const char *source);
E void rootserv_help_rehash (const char *source);
E void rootserv_help_update (const char *source);
#ifdef RAWINJECT
E void rootserv_help_raw (const char *source);
E void rootserv_help_inject (const char *source);
#endif
E void rootserv_help_resetnews (const char *source);
E void rootserv_help_logonmsg (const char *source);

