#!/bin/sh
#
# Generate version.h.

if [ -f ../inc/version.h ] ; then
BUILD=`fgrep '#define BUILD' ../inc/version.h | sed 's/^#define BUILD.*"\([0-9]*\)".*$/\1/'`
BUILD=`expr $BUILD + 1`
else
	BUILD=1
fi

cat >../inc/version.h <<EOF
/* Version information

   Cygnus IRC Services - Copyright (c) 2001-2002 Darcy Grexton
   Contact: skold@habber.net, skold @ HabberNet, ICQ #6285178

   This program is free but copyrighted software; see the file COPYING
   for details.
 */

#define BUILD "$BUILD"

const char version[] = "$1";
const char build[] = "$BUILD";
const char compile_time[] = "`date | \
awk '{if (NF == 6) \
	 { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
	 { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`";

const char *infotext[] =
{
    "Cygnus IRC Services --",
    "Copyright (c) 2001-2002 Darcy Grexton <skold@habber.net>",
    " ",
    "This program is free software, you can redistribute it and/or",
    "modify it under the terms of the GNU General Public License as",
    "published by the Free Software Foundation; either version 1, or",
    "(at your option) any later version.",
    " ",
    "The following people have donated money or hardware to the",
    "developer:",
    " ",
    "madragoran         Mike Campbell      madragoran@avendesora.net",
    "Lan                Eric Will          daishan@charter.net",
    " ",
    0,
};
EOF
